﻿namespace HeuristicLab.BenchmarkSuite.Problems {
  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc;

  public class ReplaceSpaceWithNewline : BenchmarkSuiteDataDescriptor {
    private const string name = "Replace Space with Newline";
    private const string fileName = "ReplaceSpaceWithNewline.csv";
    private const string description = " Given a string input, print the string, replacing spaces with newlines.Also, return the integer count of the non- whitespace characters. The input string will not have tabs or newlines.";

    protected override string FileName { get { return fileName; } }
    public override string Name { get { return name; } }
    public override string Description { get { return description; } }
    protected override int InputArgumentCount { get { return 1; } }
    protected override int OutputArgumentCount { get { return 2; } }

    public override ProblemData CreateProblemData() {
      return new ProblemData {
        Name = Name,
        Description = Description,
        Examples = CloneExamples(),
        BestResult = 0,
        WorstResult = 20,
        InputArgumentTypes = new[] { ExampleArgumentType.String },
        OutputArgumentTypes = new[] { ExampleArgumentType.String, ExampleArgumentType.Integer },
        TrainingCount = 100,
        TestCount = 1000,
        EnabledDataTypes = DataTypes.Exec | DataTypes.Integer | DataTypes.Boolean | DataTypes.Char | DataTypes.String,
        MaxSize = 800,
        EvalLimit = 1600,
        ErcOptions = {
          ErcProbability = 0.05,
          CharErcOptions = {
            IsEnabled = true,
            Constants = new [] { ' ', '\r' },
            Start = 0x20,
            End = 0x7e
          },
          StringErcOptions = {
            IsEnabled = true,
            AllowLowercaseLetters = true,
            AllowUppercaseLetters = false,
            AllowSpace = true,
            SpaceProbability = 0.2
          }
        }
      };
    }

    protected override Example ParseExample(string[] input, string[] output) {
      return new Example {
        InputArgs = input,
        OutputArgs = output,
        InputString = input,
        OutputString = new[] { output[0] },
        OutputInteger = ExampleArgumentConverter.ConvertIntegers(output[1]),
      };
    }
  }
}
